/*
 * a rcmd replacement for rdist that uses rsh to do all the grunt work.
*/
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<sys/wait.h>
#include	<unistd.h>
#include	<signal.h>
#include	<errno.h>
#include	<netdb.h>
#include	<stdio.h>

int rcmd(char **ahost, unsigned short port, const char *luser, const char *ruser, const char *cmd, int *fd2p)
{
	int		cpid;
	struct hostent	*rp;
	int		sp[2];

	/* insure that we are indeed being used as we thought. */
	if (fd2p != 0)
		return -1;
	/* validate remote hostname. */
	rp = gethostbyname(*ahost);
	if (rp == 0) {
		fprintf(stderr, "%s: unknown host\n", *ahost);
		return -1;
	}
	/* *ahost = hp->h_name;	 This makes me nervous. */

	/* get a socketpair we'll use for stdin and stdout. */
	if (socketpair(AF_UNIX, SOCK_STREAM, 0, sp) < 0)
		return -1;

	cpid = fork();
	if (cpid < 0)
		return -1;	/* error. */
	if (cpid == 0) {
		/* child. we use sp[1] to be stdin/stdout, and close
		   sp[0]. */
		(void) close(sp[0]);
		if (dup2(sp[1], 0) < 0 || dup2(0,1) < 0 || dup2(0, 2) < 0) {
			_exit(255);
		}
		/* fork again to loose parent. */
		cpid = fork();
		if (cpid < 0) {
			_exit(255);
		}
		if (cpid > 0)
			_exit(0);
		/* in grandchild here. */
		execlp("rsh", "rsh", *ahost, "-l", ruser, cmd, (char *) 0);
		_exit(255);
	}
	if (cpid > 0) {
		/* parent. close sp[1], return sp[0]. */
		(void) close(sp[1]);
		/* reap child. */
		(void) wait(0);
		return sp[0];
	}
	/*NOTREACHED*/
        return 0;
}
